#include <cstdlib>
#include <iostream>
#include "prof.h"
#include <conio.h>

using namespace std;

    struct MP3
    {
       string titolo;
       string autore;
       int durata;
       string url;
    };

    int num_mp3=0;

//conta le righe del file che contiene i dati sugli MP3
//per sapere  quanti elementi mettere nel vettore
//attenzione: nel file non bisogna andare a capo dopo l'ultima riga
int contaRighe(string nomeFile)
{
  int cont=0;
  string riga=leggiRiga(nomeFile);

  while(riga != "#FINITO#")
  {
    cont++;
    riga=leggiRiga(nomeFile);
  }
  return cont;

}

int carica(string nomeFile, MP3 v[])
{
   int cont=0;
   string riga = leggiRiga(nomeFile);

   while (riga != "#FINITO#")
   {
      v[cont].titolo = riga;

      riga = leggiRiga(nomeFile);
      v[cont].autore = riga;

      riga = leggiRiga(nomeFile);
      v[cont].durata = atoi(riga.c_str());

      riga = leggiRiga(nomeFile);
      v[cont].url = riga;

      riga = leggiRiga(nomeFile);
      cont ++;
   }

   return cont;
}

void salva(string nomeFile, MP3 v[], int quantiMP3)
{
   //elimino vecchi dati
   elimina(nomeFile);

   for(int i=0; i<quantiMP3; i++)
   {
      registraRiga(nomeFile, v[i].titolo);
      registraRiga(nomeFile, v[i].autore);
      registraRiga(nomeFile, intToString(v[i].durata) );
      registraRiga(nomeFile, v[i].url);
   }
}

void aggiungi(MP3 v[])
{}

void cerca(MP3 v[])
{}

void visualizzaTutti(MP3 v[], int quantiMP3)
{
    for (int i=0; i<quantiMP3; i++)
    {
      cout << "Titolo: " << v[i].titolo<< endl;
      cout << "Autore: " << v[i].autore << endl;
      cout << "Durata: " << v[i].durata << endl;
      cout << "url: " << v[i].url << endl;
      cout << "--------------------------------" << endl;
    }

     cout << "INVIO per continuare ... ";
     while (!kbhit());
}


int main(int argc, char *argv[])
{
    //il vettore ha tanti elementi quanti sono
    //gli mp3 nel file + 30 per nuovi inserimenti
    MP3 collezione[ contaRighe("mp3.txt") / 4 + 30 ];

     int scelta = -1;
    //men principale
    do
    {
      system("cls"); //pulisci schermo
      cout << "1 - Carica catalogo da disco (mp3.txt)" << endl;
      cout << "2 - Salva catalogo su disco (mp3.txt)" << endl;
      cout << "3 - Aggiungi una scheda MP3" << endl;
      cout << "4 - Cerca una scheda " << endl;
      cout << "5 - Visualizza tutti" << endl;

      cout << "9 - FINE PROGRAMMA" << endl;

      cout <<"SCEGLI -> ";
      cin >> scelta;

      switch (scelta)
      {
         case 1: num_mp3 = carica("mp3.txt", collezione);
           break;
         case 2: salva("mp3.txt", collezione, num_mp3);
           break;
         case 3: aggiungi(collezione);
           break;
         case 4: cerca(collezione);
         case 5: visualizzaTutti(collezione, num_mp3);
          break;
      }

    } while (scelta != 9);

    return EXIT_SUCCESS;
}
